Index: lib/spatial/mapbuilder/lib/widget/MapScaleBar.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/MapScaleBar.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/MapScaleBar.js	(revision 4307)
@@ -25,7 +25,7 @@
 /*
 adapted from http://mapserver.commenspace.org/tools/scalebar/
 
-$Id$
+$Id: MapScaleBar.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -45,80 +45,28 @@
 function MapScaleBar(widgetNode, model) {
   WidgetBase.apply(this,new Array(widgetNode, model));
 
-	// default properties
-	// may be modified after construction
-	// if modified after ScaleBar.place(), use ScaleBar.update()
-	this.scaleDenominator = 1;    //this will get updated on the first paint
+  // default properties
+  // may be modified after construction
+  // if modified after ScaleBar.place(), use ScaleBar.update()
+  this.scaleDenominator = 1;    //this will get updated on the first paint
 
-	this.displaySystem = 'metric'; // metric or english supported
-  var displaySystem = widgetNode.selectSingleNode("mb:displaySystem");
-  if (displaySystem) this.displaySystem = displaySystem.firstChild.nodeValue;
+  this.displaySystem = this.getProperty("mb:displaySystem", "metric"); // metric, english or nautical supported
+  this.minWidth = this.getProperty("mb:minWidth", 100); // pixels
+  this.maxWidth = this.getProperty("mb:maxWidth", 200); // pixels
+  this.divisions = this.getProperty("mb:divisions", 2);
+  this.subdivisions = this.getProperty("mb:subdivisions", 2);
+  this.showMinorMeasures = Mapbuilder.parseBoolean(this.getProperty("mb:showMinorMeasures", false));
+  this.abbreviateLabel = Mapbuilder.parseBoolean(this.getProperty("mb:abbreviateLabel", false));
+  this.singleLine = Mapbuilder.parseBoolean(this.getProperty("mb:singleLine", false));
+  this.align = this.getProperty("mb:align", "center"); // left, center, or right supported
+  this.resolution = 72; // dpi
 
-	this.minWidth = 100; // pixels
-  var minWidth = widgetNode.selectSingleNode("mb:minWidth");
-  if (minWidth) this.minWidth = minWidth.firstChild.nodeValue;
+  // create scalebar elements
+  this.containerId = this.outputNodeId;
+  this.labelContainerId = this.containerId + "Label";
+  this.graphicsContainerId = this.containerId + "Graphics";
+  this.numbersContainerId = this.containerId + "Numbers";
 
-	this.maxWidth = 200; // pixels
-  var maxWidth = widgetNode.selectSingleNode("mb:maxWidth");
-  if (maxWidth) this.maxWidth = maxWidth.firstChild.nodeValue;
-
-	this.divisions = 2;
-  var divisions = widgetNode.selectSingleNode("mb:divisions");
-  if (divisions) this.divisions = divisions.firstChild.nodeValue;
-
-	this.subdivisions = 2;
-  var subdivisions = widgetNode.selectSingleNode("mb:subdivisions");
-  if (subdivisions) this.subdivisions = subdivisions.firstChild.nodeValue;
-
-	this.showMinorMeasures = false;
-  var showMinorMeasures = widgetNode.selectSingleNode("mb:showMinorMeasures");
-  if (showMinorMeasures && showMinorMeasures.firstChild.nodeValue=="true") this.showMinorMeasures = true;
-
-	this.abbreviateLabel = false;
-  var abbreviateLabel = widgetNode.selectSingleNode("mb:abbreviateLabel");
-  if (abbreviateLabel && abbreviateLabel.firstChild.nodeValue=="true") this.abbreviateLabel = true;
-
-	this.singleLine = false;
-  var singleLine = widgetNode.selectSingleNode("mb:singleLine");
-  if (singleLine && singleLine.firstChild.nodeValue=="true") this.singleLine = true;
-
-	this.align = 'center'; // left, center, or right supported
-  var align = widgetNode.selectSingleNode("mb:align");
-  if (align) this.align = align.firstChild.nodeValue;
-
-	this.resolution = 72; // dpi
-
-	// create scalebar elements
-	this.container = document.createElement('div');
-	this.container.className = 'sbWrapper';
-	this.container.style.position = 'relative';
-	this.container.setAttribute("id",this.outputNodeId);
-	this.labelContainer = document.createElement('div');
-	this.labelContainer.className = 'sbUnitsContainer';
-	this.labelContainer.style.position = 'absolute';
-	this.graphicsContainer = document.createElement('div');
-	this.graphicsContainer.style.position = 'absolute';
-	this.graphicsContainer.className = 'sbGraphicsContainer';
-	this.numbersContainer = document.createElement('div');
-	this.numbersContainer.style.position = 'absolute';
-	this.numbersContainer.className = 'sbNumbersContainer';
-
-	// private functions
-	// put in some markers and bar pieces so style attributes can be grabbed
-	// this is a solution for Safari support
-	var markerMajor = document.createElement('div');
-	markerMajor.className = 'sbMarkerMajor';
-	this.graphicsContainer.appendChild(markerMajor);
-	var markerMinor = document.createElement('div');
-	markerMinor.className = 'sbMarkerMinor';
-	this.graphicsContainer.appendChild(markerMinor);
-	var barPiece = document.createElement('div');
-	barPiece.className = 'sbBar';
-	this.graphicsContainer.appendChild(barPiece);
-	var barPieceAlt = document.createElement('div');
-	barPieceAlt.className = 'sbBarAlt';
-	this.graphicsContainer.appendChild(barPieceAlt);
-
   /**
    * adds a bbox listener on the model 
    */
@@ -126,6 +74,62 @@
   this.model.addListener("refresh", this.update, this);
 }
 
+MapScaleBar.prototype.getContainerNode = function() {
+  var node = document.getElementById(this.containerId);
+  if (!node) {
+    var node = document.createElement('div');
+    node.className = 'sbWrapper';
+    node.style.position = 'relative';
+    node.setAttribute("id",this.containerId);
+  }
+  return node;
+}
+MapScaleBar.prototype.getGraphicsContainerNode = function() {
+  var node = document.getElementById(this.graphicsContainerId);
+  if (!node) {
+    var node = document.createElement('div');
+    node.style.position = 'absolute';
+    node.className = 'sbGraphicsContainer';
+    node.setAttribute("id",this.graphicsContainerId);
+
+    // put in some markers and bar pieces so style attributes can be grabbed
+    // this is a solution for Safari support
+    var markerMajor = document.createElement('div');
+    markerMajor.className = 'sbMarkerMajor';
+    node.appendChild(markerMajor);
+    var markerMinor = document.createElement('div');
+    markerMinor.className = 'sbMarkerMinor';
+    node.appendChild(markerMinor);
+    var barPiece = document.createElement('div');
+    barPiece.className = 'sbBar';
+    node.appendChild(barPiece);
+    var barPieceAlt = document.createElement('div');
+    barPieceAlt.className = 'sbBarAlt';
+    node.appendChild(barPieceAlt);
+  }
+  return node;
+}
+MapScaleBar.prototype.getLabelContainerNode = function() {
+  var node = document.getElementById(this.labelContainerId);
+  if (!node) {
+    var node = document.createElement('div');
+    node.className = 'sbUnitsContainer';
+    node.style.position = 'absolute';
+    node.setAttribute("id",this.labelContainerId);
+  }
+  return node;
+}
+MapScaleBar.prototype.getNumbersContainerNode = function() {
+  var node = document.getElementById(this.numbersContainerId);
+  if (!node) {
+    var node = document.createElement('div');
+    node.style.position = 'absolute';
+    node.className = 'sbNumbersContainer';
+    node.setAttribute("id",this.numbersContainerId);
+  }
+  return node;
+}
+
 /**
  * Render the widget.
  * @param objRef Pointer to widget object.
@@ -134,9 +138,9 @@
 
   //create the output node the first time this is called
   var outputNode = document.getElementById( objRef.outputNodeId );
-  if (!outputNode) objRef.node.appendChild(objRef.container);
+  if (!outputNode) objRef.getNode().appendChild(objRef.getContainerNode());
 
-  var scaleDenominator = objRef.model.extent.getScale()
+  var scaleDenominator = objRef.model.map.getScale();
 	if(scaleDenominator != null) {
 		objRef.scaleDenominator = scaleDenominator;
 	}
@@ -198,7 +202,7 @@
 				var aSheet = document.styleSheets[sheetIndex];
 				if(!aSheet.disabled) {
 					var allRules;
-					if(typeof(aSheet.cssRules) == 'undefined') {
+					if(typeof(aSheet.rules) == 'undefined') {
 						if(typeof(aSheet.rules) == 'undefined') {
 							// can't get rules, assume zero
 							return 0;
@@ -208,7 +212,7 @@
 						}
 					}
 					else {
-						allRules = aSheet.cssRules;
+						allRules = aSheet.rules;
 					}
 					for(var ruleIndex = 0; ruleIndex < allRules.length; ++ruleIndex) {
 						var aRule = allRules[ruleIndex];
@@ -245,18 +249,27 @@
 		}
 	}
 	// update the container title (for displaying scale as a tooltip)
-	objRef.container.title = 'scale 1:' + formatNumber(objRef.scaleDenominator);
+	var container = objRef.getContainerNode();
+	var graphicsContainer = objRef.getGraphicsContainerNode();
+	var labelContainer = objRef.getLabelContainerNode();
+	var numbersContainer = objRef.getNumbersContainerNode();
+	container.title = mbGetMessage("scale", formatNumber(objRef.scaleDenominator));
 	// measurementProperties holds display units, abbreviations,
 	// and conversion to inches (since we're using dpi) - per measurement sytem
 	var measurementProperties = new Object();
 	measurementProperties.english = {
-		units: ['miles', 'feet', 'inches'],
-		abbr: ['mi', 'ft', 'in'],
+		units: [mbGetMessage("unitMiles"), mbGetMessage("unitFeet"), mbGetMessage("unitInches")],
+		abbr: [mbGetMessage("unitMilesAbbr"), mbGetMessage("unitFeetAbbr"), mbGetMessage("unitInchesAbbr")],
 		inches: [63360, 12, 1]
 	}
+	measurementProperties.nautical = {
+		units: [mbGetMessage("unitNauticalMiles"), mbGetMessage("unitFeet"), mbGetMessage("unitInches")],
+		abbr: [mbGetMessage("unitNauticalMilesAbbr"), mbGetMessage("unitFeetAbbr"), mbGetMessage("unitInchesAbbr")],
+		inches: [72913.3860, 12, 1]
+	}
 	measurementProperties.metric = {
-		units: ['kilometers', 'meters', 'centimeters'],
-		abbr: ['km', 'm', 'cm'],
+		units: [mbGetMessage("unitKilometers"), mbGetMessage("unitMeters"), mbGetMessage("unitCentimeters")],
+		abbr: [mbGetMessage("unitKilometersAbbr"), mbGetMessage("unitMetersAbbr"), mbGetMessage("unitCentimetersAbbr")],
 		inches: [39370.07874, 39.370079, 0.393701]
 	}
 	// check each measurement unit in the display system
@@ -330,14 +343,14 @@
 		xOffsetMarkerMinor = 0.5;
 	}
 	// clean out any old content from containers
-	while(objRef.labelContainer.hasChildNodes()) {
-		objRef.labelContainer.removeChild(objRef.labelContainer.firstChild);
+	while(labelContainer.hasChildNodes()) {
+		labelContainer.removeChild(labelContainer.firstChild);
 	}
-	while(objRef.graphicsContainer.hasChildNodes()) {
-		objRef.graphicsContainer.removeChild(objRef.graphicsContainer.firstChild);
+	while(graphicsContainer.hasChildNodes()) {
+		graphicsContainer.removeChild(graphicsContainer.firstChild);
 	}
-	while(objRef.numbersContainer.hasChildNodes()) {
-		objRef.numbersContainer.removeChild(objRef.numbersContainer.firstChild);
+	while(numbersContainer.hasChildNodes()) {
+		numbersContainer.removeChild(numbersContainer.firstChild);
 	}
 	// create all divisions
 	var aMarker, aBarPiece, numbersBox, xOffset;
@@ -360,7 +373,7 @@
 		aMarker.style.overflow = 'hidden';
 		aMarker.style.left = Math.round(xPosition - xOffsetMarkerMajor) + 'px';
 		aMarker.appendChild(document.createTextNode(' '));
-		objRef.graphicsContainer.appendChild(aMarker);
+		graphicsContainer.appendChild(aMarker);
 		// add initial measure
 		if(!objRef.singleLine) {
 			numbersBox = document.createElement('div');
@@ -377,7 +390,7 @@
 				numbersBox.style.left = Math.round(xPosition - (objRef.subdivisions * subdivisionPixelLength)) + 'px';
 			}
 			numbersBox.appendChild(document.createTextNode(markerMeasure));
-			objRef.numbersContainer.appendChild(numbersBox);
+			numbersContainer.appendChild(numbersBox);
 		}
 		// create all subdivisions
 		for(var subdivisionIndex = 0; subdivisionIndex < objRef.subdivisions; ++subdivisionIndex) {
@@ -394,7 +407,7 @@
 				aBarPiece.style.left = Math.round(xPosition - xOffsetBarAlt) + 'px';
 			}
 			aBarPiece.appendChild(document.createTextNode(' '));
-			objRef.graphicsContainer.appendChild(aBarPiece);
+			graphicsContainer.appendChild(aBarPiece);
 			// add minor marker if not the last subdivision
 			if(subdivisionIndex < (objRef.subdivisions - 1)) {
 				// set xPosition and markerMeasure to end of subdivision
@@ -407,7 +420,7 @@
 				aMarker.style.overflow = 'hidden';
 				aMarker.style.left = Math.round(xPosition - xOffsetMarkerMinor) + 'px';
 				aMarker.appendChild(document.createTextNode(' '));
-				objRef.graphicsContainer.appendChild(aMarker);
+				graphicsContainer.appendChild(aMarker);
 				if(objRef.showMinorMeasures && !objRef.singleLine) {
 					// add corresponding measure
 					numbersBox = document.createElement('div');
@@ -418,7 +431,7 @@
 					numbersBox.style.width = Math.round(subdivisionPixelLength * 2) + 'px';
 					numbersBox.style.left = Math.round(xPosition - subdivisionPixelLength) + 'px';
 					numbersBox.appendChild(document.createTextNode(markerMeasure));
-					objRef.numbersContainer.appendChild(numbersBox);
+					numbersContainer.appendChild(numbersBox);
 				}
 			}
 		}
@@ -434,7 +447,7 @@
 	aMarker.style.overflow = 'hidden';
 	aMarker.style.left = Math.round(xPosition - xOffsetMarkerMajor) + 'px';
 	aMarker.appendChild(document.createTextNode(' '));
-	objRef.graphicsContainer.appendChild(aMarker);
+	graphicsContainer.appendChild(aMarker);
 	// add final measure
 	if(!objRef.singleLine) {
 		numbersBox = document.createElement('div');
@@ -451,7 +464,7 @@
 			numbersBox.style.left = Math.round(xPosition - (objRef.subdivisions * subdivisionPixelLength)) + 'px';
 		}
 		numbersBox.appendChild(document.createTextNode(markerMeasure));
-		objRef.numbersContainer.appendChild(numbersBox);
+		numbersContainer.appendChild(numbersBox);
 	}
 	// add content to the label container
 	var labelBox = document.createElement('div');
@@ -478,7 +491,7 @@
 		labelText += ' ' + displayUnits;
 	}
 	labelBox.appendChild(document.createTextNode(labelText));
-	objRef.labelContainer.appendChild(labelBox);
+	labelContainer.appendChild(labelBox);
 	// support for browsers without the Document.styleSheets property (Opera)
 	if(!document.styleSheets) {
 		// override custom css with default
@@ -494,7 +507,7 @@
 		document.getElementsByTagName('head').item(0).appendChild(defaultStyle);
 	}
 	// append the child containers to the parent container
-	objRef.container.appendChild(objRef.graphicsContainer);
-	objRef.container.appendChild(objRef.labelContainer);
-	objRef.container.appendChild(objRef.numbersContainer);
+	container.appendChild(graphicsContainer);
+	container.appendChild(labelContainer);
+	container.appendChild(numbersContainer);
 }
Index: lib/spatial/mapbuilder/lib/widget/Measurement.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Measurement.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/Measurement.js	(revision 4307)
@@ -0,0 +1,190 @@
+/*
+Author: imke doerge AT geodan.nl
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: Measurement.js 3821 2008-02-01 13:58:30Z ahocevar $
+*/
+
+// Ensure this object's dependencies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/EditButtonBase.js");
+
+
+/**
+ * When this button is selected, clicks on the MapPane will add a
+ * new point to a line and the total distance of the line will be calculated
+ * @constructor
+ * @base EditButtonBase
+ * @author Imke Doerge AT geodan.nl
+ * @param widgetNode The widget from the Config XML file.
+ * @param model  The parent model for this  widget.
+ */
+function Measurement(widgetNode, model) {
+  EditButtonBase.apply(this, new Array(widgetNode, model));
+
+  /**
+   * Interactive EditLine control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
+   */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class(OpenLayers.Control.DrawFeature, {
+      // this is needed because all editing tools are of type
+      // OpenLayers.Control.DrawFeature
+      CLASS_NAME: 'mbMeasurement'
+    });
+    return Control;
+  }
+  
+  this.instantiateControl = function(objRef, Control) {
+     var control = new Control(objRef.featureLayer, OpenLayers.Handler.Path,
+          {callbacks: {point: objRef.startAction}});
+    control.objRef = objRef;
+    control.activate = function() {
+      Control.prototype.activate.apply(this, arguments);
+      objRef.targetModel.setParam('showDistance', 0);
+    }
+    control.deactivate = function() {
+      Control.prototype.deactivate.apply(this, arguments);
+      objRef.targetModel.setParam('showDistance', null);
+    }
+    return control;
+  }
+  
+  // override default cursor by user
+  // cursor can be changed by specifying a new cursor in config file
+  this.cursor = "crosshair";	
+        
+  var totalDistance=0;
+  var distance = 0;
+  var state = false;
+  var restart = false;
+  
+  this.startAction = function(pointGeometry) {
+    var objRef = this.objRef;
+    objRef.pointGeometry = pointGeometry;
+    if (!objRef.targetModel.doc) {
+      objRef.targetModel.addListener("loadModel", objRef.doAction, objRef);
+      config.loadModel(objRef.targetModel.id, objRef.defaultModelUrl);
+    } else {
+      objRef.doAction(objRef);
+    }
+  }
+  /**
+   * Append a point to a line and calculate the distance between all
+   * points on the line. This will be called by the OpenLayers control
+   * for this widget in the context of the control.
+   * @param pointGeometry OpenLayers Geometry of the point to add
+   */
+  this.doAction = function(objRef) {
+    pointGeometry = objRef.pointGeometry;
+    objRef.targetModel.removeListener("loadModel", objRef.doAction, objRef);
+    if (objRef.enabled) {
+		  if(objRef.restart) {
+        objRef.model.setParam("clearMeasurementLine");
+			  objRef.restart= false;
+			}
+      var point=[pointGeometry.x, pointGeometry.y];
+      var old=objRef.targetModel.getXpathValue(objRef.targetModel,objRef.featureXpath);
+      if(!old) old="";
+        sucess=objRef.targetModel.setXpathValue(objRef.targetModel,objRef.featureXpath,old+" "+point[0]+","+point[1]);
+      if(!sucess) {
+        alert(mbGetMessage("invalidFeatureXpathMeasurement", objRef.featureXpath));
+      }
+			
+      var lineCoords = objRef.targetModel.getXpathValue(objRef.targetModel, objRef.featureXpath);
+      var coordArray = lineCoords.split(" ");
+      if (coordArray.length >= 3) {
+        var point_P = coordArray[coordArray.length-2];
+        var point_Q = coordArray[coordArray.length-1];
+            
+        //Split point in x and y coordinate
+        var P =point_P.split(",");
+        var Q =point_Q.split(",");
+              
+        //transform coordinates from lat/lon to x/y in meter 
+        objRef.srs = srs.toUpperCase();
+        objRef.proj = new OpenLayers.Projection(objRef.srs);
+        
+        if (!P || !Q  ){
+          alert(mbGetMessage("projectionNotSupported"));
+        }
+        else {
+          //If projection is in meters use simple pythagoras
+          if(objRef.proj.getUnits() == "meters" || objRef.proj.getUnits() == "m") {
+            Xp=parseFloat(P[0]);
+            Yp=parseFloat(P[1]);
+            Xq=parseFloat(Q[0]);
+            Yq=parseFloat(Q[1]);
+            // calculate the distance between these two points via Pythagoras' theorem  
+            distance=Math.sqrt(((Xp-Xq)*(Xp-Xq))+((Yp-Yq)*(Yp-Yq)))
+			      if(distance==0) {
+              objRef.restart = true;
+              objRef.model.setParam("clearMouseLine");objRef.targetModel.setParam("mouseRenderer", false);
+		    		return;
+				  	}
+            totalDistance = Math.round(totalDistance + distance);
+          }
+          //If projection is in degrees use great circle formulae 
+          //http://williams.best.vwh.net/avform.htm#GCF
+          else if(objRef.proj.getUnits() == "degrees" || objRef.proj.getUnits() == null) {
+            var deg2rad = Math.PI / 180.0
+            var centerOfEarth=new Array(0,0);
+            LonpRad=parseFloat(P[0]) * deg2rad;
+            LatpRad=parseFloat(P[1]) * deg2rad;
+            LonqRad=parseFloat(Q[0]) * deg2rad;
+            LatqRad=parseFloat(Q[1]) * deg2rad;
+            
+            if((LonpRad>0 && LonqRad<0) || (LonpRad<0 && LonqRad>0)){
+	            if(LonpRad<0){
+	           	 	radDistance=Math.acos(Math.sin(LatpRad)*Math.sin(LatqRad)+Math.cos(LatpRad)*Math.cos(LatqRad)*Math.cos(LonpRad));
+	            	radDistance+=Math.acos(Math.sin(LatpRad)*Math.sin(LatqRad)+Math.cos(LatpRad)*Math.cos(LatqRad)*Math.cos(LonqRad));
+	            }
+	            if(LonqRad<0){
+	            	radDistance=Math.acos(Math.sin(LatpRad)*Math.sin(LatqRad)+Math.cos(LatpRad)*Math.cos(LatqRad)*Math.cos(LonqRad));
+	            	radDistance+=Math.acos(Math.sin(LatpRad)*Math.sin(LatqRad)+Math.cos(LatpRad)*Math.cos(LatqRad)*Math.cos(LonpRad));
+	            }
+             }
+             else{
+             
+            	radDistance=Math.acos(Math.sin(LatpRad)*Math.sin(LatqRad)+Math.cos(LatpRad)*Math.cos(LatqRad)*Math.cos(LonpRad-LonqRad));
+            
+            }
+            //radDistance=Math.acos(Math.sin(Latp)*Math.sin(Latq)+Math.cos(Latp)*Math.cos(Latq)*Math.cos(Lonp-Lonq));
+            distance =radDistance * 6378137;
+            if(distance==0) {
+              objRef.restart = true;
+              objRef.model.setParam("clearMouseLine");objRef.targetModel.setParam("mouseRenderer", false);
+            return;
+            }
+            totalDistance = Math.round(totalDistance + distance);
+          }
+          else alert(mbGetMessage("cantCalculateDistance"));
+        }
+      }    
+      objRef.targetModel.setParam("showDistance", totalDistance); // set parameter for the distance output
+    }
+  }
+  
+  /**
+   * This will be called as defined in EditButtonBase.js. It is called
+   * when measurement is finished (ie. when user double-clicks on the map)
+   * @param objRef reference to this widget
+   * @param feature complete measurement path - currently unused.
+   */
+  this.setFeature = function(objRef, feature) {
+    objRef.restart = true;
+  }
+    
+  this.clearMeasurementLine = function(objRef){
+    if (totalDistance !=0) {
+      totalDistance=0;
+      sucess=objRef.targetModel.setXpathValue(objRef.targetModel,objRef.featureXpath,"");
+      if(!sucess){
+        alert(mbGetMessage("invalidFeatureXpathMeasurement", objRef.featureXpath));
+      }
+      objRef.targetModel.setParam("refresh");
+    }
+  }
+  //add a Listener to the model
+	this.model.addListener("clearMeasurementLine", this.clearMeasurementLine, this);
+
+}
Index: lib/spatial/mapbuilder/lib/widget/GetFeatureInfo.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/GetFeatureInfo.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/GetFeatureInfo.js	(revision 4307)
@@ -1,11 +1,11 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
 Dependancies: Context
-$Id$
+$Id: GetFeatureInfo.js 3906 2008-03-05 10:27:30Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
-mapbuilder.loadScript(baseDir+"/tool/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
 /**
  * Implements WMS GetFeatureInfo functionality, popping up a query result
  * window when user clicks on map.
@@ -16,94 +16,111 @@
  * @param toolNode The XML node in the Config file referencing this object.
  * @param model The widget object which this tool is associated with.
  */
-function GetFeatureInfo(toolNode, model) {
+function GetFeatureInfo(widgetNode, model) {
   // Extend ButtonBase
-  ButtonBase.apply(this, new Array(toolNode, model));
+  ButtonBase.apply(this, new Array(widgetNode, model));
 
   /** Xsl to build a GetFeatureInfo URL */
-  this.xsl=new XslProcessor(baseDir+"/tool/GetFeatureInfo.xsl");
+  this.xsl = new XslProcessor(
+      this.getProperty("mb:stylesheet", baseDir+"/tool/GetFeatureInfo.xsl"));
   
-  /** Determine whether Query result is returned as HTML or GML */
-  // TBD This should be stored in the Config file.
-  //this.infoFormat="application/vnd.ogc.gml";
-  //this.infoFormat="text/plain";
-  this.infoFormat="text/html";
+  /**
+   * Determine whether Query result is returned as text, HTML or GML
+   * This is usually text/plain, text/html or application/vnd.ogc.gml
+   */
+  this.infoFormat = this.getProperty("mb:infoFormat", "application/vnd.ogc.gml");
 
+  // Get the value for featureCount from the configfile
+  this.featureCount = this.getProperty("mb:featureCount", 1);
+
+  this.cursor = "pointer"; 
+
   /**
-   * Open window with query info.
-   * This function is called when user clicks map with Query tool.
-   * @param objRef      Pointer to this GetFeatureInfo object.
-   * @param targetNode  The node for the enclosing HTML tag for this widget.
+   * GetFeatureInfo control
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
    */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      CLASS_NAME: 'mbControl.GetFeatureInfo',
+      type: OpenLayers.Control.TYPE_TOOL,
+      draw: function() {
+        this.handler = new OpenLayers.Handler.Box( this,
+          {done: this.zoomBox}, {keyMask: this.keyMask} );
+      },
+      zoomBox: function(position) {
+        var objRef = this.objRef
+        if (objRef.enabled) {
+          var x,y;
+          if (position instanceof OpenLayers.Bounds) {
+            x = position.left + (position.right - position.left) / 2;
+            y = position.top + (position.bottom - position.top) / 2;
+          } else {
+            x = position.x;
+            y = position.y;
+          }
+          objRef.targetModel.deleteTemplates();
+          var selectedLayer=objRef.targetContext.getParam("selectedLayer");
+          if (selectedLayer==null) {
+            var queryList=objRef.targetContext.getQueryableLayers();
+          	if (queryList.length==0) {
+               alert(mbGetMessage("noQueryableLayers"));
+               return;
+          	}
+            else {
+              for (var i=0; i<queryList.length; ++i) {
+                var layerNode = queryList[i];
+                
+                // Get the name of the layer
+                var layerName = Mapbuilder.getProperty(layerNode, "wmc:Name", "");
 
-  this.doAction = function(objRef,targetNode) {
-    if (objRef.enabled) {
-      objRef.targetModel.deleteTemplates();
-      var selectedLayer=objRef.context.getParam("selectedLayer");
-      if (selectedLayer==null) {
-        var queryList=objRef.context.getQueryableLayers();
-      	if (queryList.length==0) {
-           alert("There are no queryable layers available, please add a queryable layer to the context.");
-           return;
-      	}
-        else {
-          for (var i=0; i<queryList.length; ++i) {
-            var layerNode=queryList[i];
-            var layerName=layerNode.firstChild.data;
-            var hidden = objRef.context.getHidden(layerName);
-            if (hidden == 0) { //query only visible layers
-              objRef.xsl.setParameter("queryLayer", layerName);
-              objRef.xsl.setParameter("xCoord", targetNode.evpl[0]);
-              objRef.xsl.setParameter("yCoord", targetNode.evpl[1]);
-              objRef.xsl.setParameter("infoFormat", objRef.infoFormat);
-              objRef.xsl.setParameter("featureCount", "1");
+                // Get the layerId. Fallback to layerName if non-existent
+                var layerId = layerNode.getAttribute("id") || layerName;
 
-              urlNode=objRef.xsl.transformNodeToObject(objRef.context.doc);
-              url=urlNode.documentElement.firstChild.nodeValue;
-              httpPayload = new Object();
-  	          httpPayload.url = url;
+                var hidden = objRef.targetContext.getHidden(layerId);
+                if (hidden == 0) { //query only visible layers
+                  objRef.xsl.setParameter("queryLayer", layerName);
+                  objRef.xsl.setParameter("layer",layerName);
+    				      objRef.xsl.setParameter("xCoord", x);
+                  objRef.xsl.setParameter("yCoord", y);
+                  objRef.xsl.setParameter("infoFormat", objRef.infoFormat);
+                  objRef.xsl.setParameter("featureCount", objRef.featureCount);
+    
+                  urlNode=objRef.xsl.transformNodeToObject(objRef.targetContext.doc);
+                  url=getNodeValue(urlNode.documentElement);
+                  httpPayload = new Object();
+      	          httpPayload.url = url;
+                  httpPayload.method="get";
+                  httpPayload.postData=null;
+                  objRef.targetModel.newRequest(objRef.targetModel,httpPayload);
+                }
+              }
+            }
+          }
+          else {
+            objRef.xsl.setParameter("queryLayer", selectedLayer);
+            objRef.xsl.setParameter("layer", layerName);
+            objRef.xsl.setParameter("xCoord", x);
+            objRef.xsl.setParameter("yCoord", y);
+            objRef.xsl.setParameter("infoFormat", objRef.infoFormat);
+            objRef.xsl.setParameter("featureCount", objRef.featureCount);
+  
+            var urlNode=objRef.xsl.transformNodeToObject(objRef.targetContext.doc);
+            var url=getNodeValue(urlNode.documentElement);
+  
+            if (objRef.infoFormat=="text/html"){
+              window.open(url,'queryWin','height=200,width=300,scrollbars=yes');
+            } else {
+              var httpPayload = new Object();
+              httpPayload.url = url;
               httpPayload.method="get";
               httpPayload.postData=null;
               objRef.targetModel.newRequest(objRef.targetModel,httpPayload);
-              }
             }
           }
         }
-        else {
-          objRef.xsl.setParameter("queryLayer", selectedLayer);
-          objRef.xsl.setParameter("xCoord", targetNode.evpl[0]);
-          objRef.xsl.setParameter("yCoord", targetNode.evpl[1]);
-          objRef.xsl.setParameter("infoFormat", objRef.infoFormat);
-          objRef.xsl.setParameter("featureCount", "1");
-
-          var urlNode=objRef.xsl.transformNodeToObject(objRef.context.doc);
-          var url=urlNode.documentElement.firstChild.nodeValue;
-
-          if (objRef.infoFormat=="text/html"){
-            window.open(url,'queryWin','height=200,width=300,scrollbars=yes');
-          } else {
-            var httpPayload = new Object();
-            httpPayload.url = url;
-            httpPayload.method="get";
-            httpPayload.postData=null;
-            objRef.targetModel.newRequest(objRef.targetModel,httpPayload);
-          }
-        }
       }
-    }
-
-  /**
-   * Register for mouseUp events.
-   * @param objRef  Pointer to this object.
-   */
-  this.setMouseListener = function(objRef) {
-    if (objRef.mouseHandler) {
-      objRef.mouseHandler.model.addListener('mouseup',objRef.doAction,objRef);
-    }
-    objRef.context=objRef.widgetNode.selectSingleNode("mb:context");
-    if (objRef.context){
-      objRef.context=eval("config.objects."+objRef.context.firstChild.nodeValue);
-    }
+    });
+    return Control;
   }
-  config.addListener( "loadModel", this.setMouseListener, this );
 }
